/*-*- c++ -*-*/

#ifndef _PYANIM_H_
#define _PYANIM_H_

/* for encoding files */
#include <ffmpeg/avformat.h>
#include <ffmpeg/avcodec.h>
#include <ffmpeg/avio.h>

/* for interfacing with Python */
#include <boost/python.hpp>
#include <boost/python/numeric.hpp>

#define RGB_STRIDE 3

class video {
protected:
  AVOutputFormat *fmt;
  AVFormatContext *oc;
  AVStream *video_st;
  uint8_t *video_outbuf;
  int video_outbuf_size;
  AVFrame *picture, *tmp_picture;
  unsigned width, height;
public:
  video(const char *filename, unsigned w, unsigned h, 
        int framerate, int bitrate);
  ~video();
  void python_write_frame(boost::python::list &l);
  void write_frame(uint8_t *image);
  void close();
protected:
  void create(const char *filename);
  AVStream *add_video_stream(AVFormatContext *octx, int codec_id,
                             int framerate, int bitrate);
  AVFrame *alloc_picture(int pix_fmt, int width, int height);
  void open_video();
  void copy_image(AVFrame *pict, uint8_t *image);
  void close_video(AVFormatContext *oc, AVStream *st);
};


#endif
